import * as ts from "typescript";
export interface ICompilerOptions {
    ignoreGenerics?: boolean;
    ignoreIndexSignature?: boolean;
    inlineImports?: boolean;
}
export declare class Compiler {
    private checker;
    private options;
    private topNode;
    static compile(filePath: string, options?: ICompilerOptions): string;
    private exportedNames;
    constructor(checker: ts.TypeChecker, options: ICompilerOptions, topNode: ts.SourceFile);
    private getName(id);
    private indent(content);
    private compileNode(node);
    private compileOptType(typeNode);
    private _compileIdentifier(node);
    private _compileParameterDeclaration(node);
    private _compilePropertySignature(node);
    private _compileMethodSignature(node);
    private _compileTypeReferenceNode(node);
    private _compileFunctionTypeNode(node);
    private _compileTypeLiteralNode(node);
    private _compileArrayTypeNode(node);
    private _compileTupleTypeNode(node);
    private _compileUnionTypeNode(node);
    private _compileLiteralTypeNode(node);
    private _compileEnumDeclaration(node);
    private _compileInterfaceDeclaration(node);
    private _compileTypeAliasDeclaration(node);
    private _compileExpressionWithTypeArguments(node);
    private _compileParenthesizedTypeNode(node);
    private _compileImportDeclaration(node);
    private _compileSourceFileStatements(node);
    private _compileSourceFile(node);
    private _compileIndexSignatureDeclaration(node);
}
/**
 * Main entry point when used from the command line.
 */
export declare function main(): void;
